on startMovie
  global levellist, mouthpiece, BugCastList, Color1List, Color2List, sinlist, genscript, lastchan, bugchanstart, bugchanend, sblist, bugdef, availchan, direct1
  set mouthpiece to the number of cast "mouthies"
  if listp(levellist) then
    set game8level to getAt(levellist, 8)
  end if
  set availchan to [20, 21, 22, 23, 24, 25, 26, 27, 28, 29, 30, 31, 32, 33, 34, 35, 36, 37, 38, 39, 40]
  set bugchanstart to 20
  set bugchanend to 30
  set lastchan to bugchanstart
  set sblist to [:]
  set bugdef to [1, 79, 0, 255, 0, 100, 36]
  set genscript to the number of cast "bugs"
  set Color1List to ["r": "Red", "or": "Orange", "y": "Yellow", "g": "Green", "b": "Blue", "p": "Purple", "pk": "Pink", "br": "Brown", "gr": "Gray", "bk": "Black"]
  set Color2List to ["r/g": "Red & Green", "o/b": "Orange & Blue", "y/p": "Yellow & Purple", "g/b": "Green & Blue", "b/pk": "Blue & Pink", "p/o": "Orange & Purple", "pk/r": "Pink & Red", "br/y": "Brown & Yellow", "gr/o": "Gray & Orange", "bk/y": "Black & Yellow"]
  set BugCastList to ["r": [71, 73, 75, 77, 79, 81, 83, 85, 87, 89], "or": [91, 93, 95, 97, 99, 101, 103, 105, 107, 109], "y": [111, 113, 115, 117, 119, 121, 123, 125, 127, 129], "g": [131, 133, 135, 137, 139, 141, 143, 145, 147, 149], "b": [151, 153, 155, 157, 159, 161, 163, 165, 167, 169], "p": [171, 173, 175, 177, 179, 181, 183, 185, 187, 189], "pk": [191, 193, 195, 197, 199, 201, 203, 205, 207, 209], "br": [211, 213, 215, 217, 219, 221, 223, 225, 227, 229], "gr": [231, 233, 235, 237, 239, 241, 243, 245, 247, 249], "bk": [251, 253, 255, 257, 259, 261, 263, 265, 267, 269], "r/g": [352, 354, 356, 358, 360, 342, 344, 346, 348, 350], "o/b": [372, 374, 376, 378, 380, 362, 364, 366, 368, 370], "y/p": [392, 394, 396, 398, 400, 382, 384, 386, 388, 390], "g/b": [412, 414, 416, 418, 420, 402, 404, 406, 408, 410], "b/pk": [432, 434, 436, 438, 440, 422, 424, 426, 428, 430], "p/o": [452, 454, 456, 458, 460, 442, 444, 446, 448, 450], "pk/r": [472, 474, 476, 478, 480, 462, 464, 466, 468, 470], "br/y": [492, 494, 496, 498, 500, 482, 484, 486, 488, 490], "gr/o": [512, 514, 516, 518, 520, 502, 504, 506, 508, 510], "bk/y": [532, 534, 536, 538, 540, 522, 524, 526, 528, 530]]
  set sinlist to [2, 3, 4, 6, 7, 7, 8, 8, 8, 7, 7, 6, 4, 3, 2, 0, -2, -3, -4, -6, -7, -7, -8, -8, -8, -7, -7, -6, -4, -3, -2, 0, 2, 3, 4, 6, 7, 7, 8, 8, 8, 7, 7, 6, 4, 3, 2, 0, -2, -3, -4, -6, -7, -7, -8, -8, -8, -7, -7, -6, -4, -3, -2, 0]
  set direct1 to [[0, -1], [0, -1], [-1, 0], [0, -1], [0, -1], [-1, 0], [1, 0], [0, -1], [0, -1], [0, -1]]
end

on stopMovie
  repeat with xxx = 1 to 48
    set the visible of sprite xxx to 1
  end repeat
end

on findchan
  global availchan
  if count(availchan) = 0 then
    exit
  end if
  set rump to getAt(availchan, count(availchan))
  deleteAt(availchan, count(availchan))
  return rump
end

on genbuglist
  global BugCastList1, BugCastList2, Color1List, Color2List
  set Color1List to ["r": "Red", "or": "Orange", "y": "Yellow", "g": "Green", "b": "Blue", "p": "Purple", "pk": "Pink", "br": "Brown", "gr": "Gray", "bk": "Black"]
  set Color2List to ["r/g": "Red & Green", "o/b": "Orange & Blue", "y/p": "Yellow & Purple", "g/b": "Green & Blue", "b/pk": "Blue & Pink", "p/o": "Orange & Purple", "pk/r": "Pink & Red", "br/y": "Brown & Yellow", "gr/o": "Gray & Orange", "bk/y": "Black & Yellow"]
  set BugCastList1 to [:]
  repeat with yyy = 1 to count(Color1List)
    set temp to []
    set acolor to getPropAt(Color1List, yyy)
    repeat with xxx = 1 to 10
      add(temp, the number of cast ("bug" & xxx & "." & acolor & ".0"))
    end repeat
    addProp(BugCastList1, acolor, temp)
  end repeat
  set BugCastList2 to [:]
  repeat with yyy = 1 to count(Color2List)
    set temp to []
    set acolor to getPropAt(Color2List, yyy)
    repeat with xxx = 1 to 10
      add(temp, the number of cast ("bug" & xxx & "." & acolor & ".0"))
    end repeat
    addProp(BugCastList2, acolor, temp)
  end repeat
end

on gencycle
  global cyclelist
  set cyclelist to []
  set divstep to 4 * PI / 64
  repeat with xxx = 1 to 64
    add(cyclelist, integer(8 * sin(xxx * divstep)))
  end repeat
  put cyclelist
end

on lictor
  global sblist, deathmarch, availchan
  if listp(deathmarch) then
    if count(deathmarch) > 0 then
      repeat with xxx = 1 to count(deathmarch)
        set the castNum of sprite getAt(deathmarch, xxx) to -1
        deleteProp(sblist, getAt(deathmarch, xxx))
        add(availchan, getAt(deathmarch, xxx))
      end repeat
      set deathmarch to []
    end if
  end if
end

on animateall
  global sblist
  repeat with xxx = 1 to count(sblist)
    animate(getAt(sblist, xxx))
  end repeat
end

on maincycle
  global duff, bugspeed, gamerate, sblist, dtime
  repeat while (the timer - dtime) < 3
    updateStage()
  end repeat
  set dtime to the timer
  animateall()
  lictor()
  if count(sblist) < 6 then
    gennew()
  end if
end

on gennew
  global sblist, Color1List, Color2List, game8level, genscript, bugseeking
  if random(10) = 1 then
    if game8level = 1 then
      set mycolor to getPropAt(Color1List, random(count(Color1List)))
    else
      set mycolor to getPropAt(Color2List, random(count(Color2List)))
    end if
    if random(game8level + 2) = 1 then
      set mycolor to bugseeking
    end if
    set ogre to birth(script genscript, mycolor, random(10))
    if objectp(ogre) then
      setaProp(sblist, the bugchan of ogre, ogre)
    end if
  end if
end

on scarebugs
  global sblist
  puppetSound("runaway")
  repeat while count(sblist)
    repeat with xxx = 1 to count(sblist)
      set temp to getAt(sblist, xxx)
      set the bugincx of temp to the bugincx of temp * 1.10000000000000009
      set the bugincy of temp to the bugincy of temp * 1.10000000000000009
    end repeat
    animateall()
    lictor()
    updateStage()
  end repeat
  puppetSound(0)
end

on giveinstructions
  global mouthpiece
  set talklist to ["narr1", "narr2", "narr3", "narr4", "narr5"]
  set pmouth to mouthpiece
  repeat with xxx = 1 to count(talklist)
    set ptime to the timer
    set pphrase to getAt(talklist, xxx)
    set etime to 15 + (the size of cast pphrase / 183)
    puppetSound(pphrase)
    updateStage()
    set mouthtime to the timer + 5
    repeat while the timer < (ptime + etime)
      if the timer > mouthtime then
        set the castNum of sprite 3 to pmouth + random(5)
        set mouthtime to the timer + 5
        updateStage()
      end if
      if the mouseDown then
        puppetSound(0)
        abort()
      end if
    end repeat
    set the castNum of sprite 3 to pmouth + 1
  end repeat
end

on identifybluebug
  set pphrase to "Sound 708"
  set pmouth to -1 + the castNum of sprite 2
  set ptime to the timer
  set etime to 5 + (the size of cast pphrase / 183)
  puppetSound(pphrase)
  updateStage()
  set mouthtime to the timer + 5
  repeat while the timer < (ptime + etime)
    if the timer > mouthtime then
      set the castNum of sprite 2 to pmouth + random(3)
      set mouthtime to the timer + 5
      updateStage()
    end if
    if the mouseDown then
      puppetSound(0)
      abort()
    end if
  end repeat
  set the castNum of sprite 2 to pmouth + 1
end
